VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Stack"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IContainer

'----------------------------------------------------
'- HEAP DECLARATIONS --------------------------------
Private Enum Pointer
    [_]
End Enum
'----------------------------------------------------

Private Type StackItem
    Content As String
    Next_   As Pointer
End Type

Private Type MemSeg
    Flag    As Byte
    Seg     As StackItem
End Type
'----------------------------------------------------

Private m_HeapSize  As Long
Private Heap()      As MemSeg
Private m_Dynamic   As Boolean
Private m_Steps     As Long
'----------------------------------------------------
'----------------------------------------------------

Private m_Top   As Pointer
Private m_Count As Long
'----------------------------------------------------

Private Sub Class_Initialize()
    Call SetHeapSize(10)
    Call SetDynamic(True, 10)
End Sub

Private Sub Class_Terminate()
    Call IContainer_Clear
End Sub
'----------------------------------------------------

Private Sub IContainer_Clear()
    Dim pIter As Long
    
    Do While m_Top
        pIter = m_Top
        m_Top = Heap(m_Top).Seg.Next_
        Call Free(pIter)
    Loop
    
    m_Count = 0
End Sub

Private Function IContainer_Clone() As IContainer
    Dim pIter As Pointer
    Dim Steps As Long
    Dim I     As Long
    
    Set IContainer_Clone = New Stack
    
    Steps = m_Count
    
    Do While Steps > 0
        pIter = m_Top
        For I = 1 To Steps - 1
            pIter = Heap(pIter).Seg.Next_
        Next I
        
        Call IContainer_Clone.Push(Heap(pIter).Seg.Content)
        Steps = Steps - 1
    Loop
End Function

Private Property Get IContainer_Peek() As String
    If m_Count > 0 Then _
        IContainer_Peek = Heap(m_Top).Seg.Content
End Property

Private Sub IContainer_Push(Item As String)
    If m_Count = 0 Then
        m_Top = Alloc()
        Heap(m_Top).Seg.Content = Item
    Else
        Dim pTmp As Pointer
        
        pTmp = Alloc()
        Heap(pTmp).Seg.Content = Item
        Heap(pTmp).Seg.Next_ = m_Top
        m_Top = pTmp
    End If
    
    m_Count = m_Count + 1
End Sub

Private Function IContainer_Pop() As String
    If m_Count > 0 Then
        Dim pTmp As Pointer
        
        pTmp = m_Top
        
        IContainer_Pop = Heap(m_Top).Seg.Content
        m_Top = Heap(m_Top).Seg.Next_
        Call Free(pTmp)
        
        m_Count = m_Count - 1
    End If
End Function

Private Property Get IContainer_Size() As Long
    IContainer_Size = m_Count
End Property

'----------------------------------------------------
'- HEAP IMPLEMENTATION ------------------------------
Private Sub SetHeapSize(Size As Long)
    m_HeapSize = Size
    ReDim Heap(1 To Size)
End Sub

Private Sub ReSize(Size As Long)
    m_HeapSize = Size
    ReDim Preserve Heap(1 To Size)
End Sub

Private Sub SetDynamic(Enabled As Boolean, Steps As Long)
    m_Dynamic = Enabled
    m_Steps = Steps
End Sub

Private Function Alloc() As Pointer
    For Alloc = 1 To m_HeapSize
        If Heap(Alloc).Flag = 0 Then
            Heap(Alloc).Flag = 1
            Exit Function
        End If
    Next Alloc
    
    If m_Dynamic Then
        Call ReSize(m_HeapSize + 10)
        Heap(Alloc).Flag = 1
    Else
        Call Err.Raise(vbObjectError, "GC::Alloc", "Heap overflow")
    End If
End Function

Private Sub Free(Segment As Pointer)
    Heap(Segment).Flag = 0
End Sub
